Subject: Re: bug#16038: 24.3; latest change to with-help-window makes temp-buffer-browse useless

From: martin rudalics <[email-masked]>
Date: Sat, 25 Jan 2014 19:25:36 +0100

>> First re-read the thread of bug#8368.  Then read the doc-string of
 >> `with-temp-buffer-window'.  Then re-read the thread of bug#8368.
 >> Then re-read the doc-string ...
 >
 > I have.  But why do you say that

To help you understand what you are saying.

 > -- is bug #8368 fixed?

I don't know and I don't care.  I almost forgot about it until you
decided to participate in the present thread.

 > If you have a concrete suggestion, please offer it.
 > And what is the "problem" that needs fixing with my not having
 > any code that uses `with-temp-buffer-window'?

The one you apparently have with `with-output-to-temp-buffer'.

 > If bug #8368 is now fixed, great: What code to replace with what
 > code, concretely?

Your code that uses `with-output-to-temp-buffer'.

 > Are the misnamed macros and hooks being renamed
 > as well?
 >
 > I don't see that in the doc string of `with-temp-buffer-window'.
 > If a macro and the hooks it uses are all about *Help* then they
 > should not be named `with-output-to-temp-buffer',
 > `temp-buffer-setup-hook' etc.  They should have "help" in their
 > names instead of "temp".   ===> bug #8368.
 >
 > Adding new hooks that have almost the same names but very different
 > meanings and uses is a bad idea.  `temp-buffer-window-setup-hook'
 > and `temp-buffer-setup-hook' sound like they would be similar, with
 > the difference being "window".  Alas no.
 >
 > I don't have a problem with your new names.  The problem is with
 > the old names, and with not deprecating them, _especially_ after
 > adding false-friend new names.
 >
 > The old macros and hooks should be renamed to use "help" - with
 > aliases provided for the old names, with deprecation of the old
 > names, and preferably with no plan to _ever_ desupport the old
 > names.  (Deprecation does not imply desupport.  It allows for
 > later desupport, but in some cases desupport is not possible or
 > advisable or necessary.)

Maybe Leo would have started to do that if you had not interfered.  I
suggest you apologize and consult with him on how to proceed on this
matter.

 > FWIW, the NEWS is, I would think, one good place to put
 > deprecation notices.  If `with-output-to-temp-buffer' is
 > deprecated, we should learn in the NEWS that this is the case
 > AND what it is replaced by. IOW, tell users how to update their
 > code.  Likewise for the misnamed hooks etc.
 >
 > Instead, at least so far, NEWS has only this:
 >
 >   *** New macro `with-temp-buffer-window', similar to
 >   `with-output-to-temp-buffer'.
 >
 > That "similar to" might do more harm than help.

That's life.

martin